djangocms_portfolio/urls.py
from django.conf.urls import url
from . import views

app_name = "djangocms_portfolio"

urlpatterns = [
    url(r"^$", views.PortfolioListView.as_view(), name="portfolio-list"),
    url(r"^detail/(?P<work_slug>[-\w]+)/(?P<project_id>[0-9]+)/$", views.PortfolioDetailView.as_view(), name="portfolio-detail"),
    url(r'works/$', views.WorkListView.as_view(), name="work-list"),
    url(r"^works/detail/(?P<slug>[-\w]+)/$", views.WorkDetailView.as_view(), name="work-detail"),
]

web_mvc/urls.py
# -*- coding: utf-8 -*-
from __future__ import absolute_import, print_function, unicode_literals

from cms.sitemaps import CMSSitemap
from django.conf import settings
from django.conf.urls import include, url
from django.conf.urls.i18n import i18n_patterns
from django.contrib import admin
from django.contrib.sitemaps.views import sitemap
from django.contrib.staticfiles.urls import staticfiles_urlpatterns
from django.views.static import serve

admin.autodiscover()

urlpatterns = [
    url(r'^sitemap\.xml$', sitemap,{'sitemaps': {'cmspages': CMSSitemap}}),
]

urlpatterns += i18n_patterns(
    url(r'^admin/', include(admin.site.urls)),
    #url(r'^portfolio/', include("djangocms_portfolio.urls", namespace="djangocms_portfolio", app_name='djangocms_portfolio')),
    url(r'^', include('cms.urls')),
)

# This is only needed when using runserver.
if settings.DEBUG:
    urlpatterns = [
        url(r'^media/(?P<path>.*)$', serve,
            {'document_root': settings.MEDIA_ROOT, 'show_indexes': True}),
        ] + staticfiles_urlpatterns() + urlpatterns

djangocms_portfolio/models.py
# coding: utf-8
from django.db import models
from cms.models import CMSPlugin, PlaceholderField
from django.core.exceptions import ValidationError
from django.utils.translation import get_language, ugettext, ugettext_lazy as _
from django.urls import reverse
from parler.models import TranslatableModel, TranslatedFields
from meta.models import ModelMeta
from filer.fields.image import FilerImageField

from .settings import get_setting

class WorkType(TranslatableModel):
    translations = TranslatedFields(
        name = models.CharField(verbose_name=_("name"), max_length=100),
        slug = models.SlugField(),
        meta_description=models.TextField(
            verbose_name=_('project meta description'), blank=True, default=''
        ),
        meta_keywords=models.TextField(verbose_name=_('project meta keywords'),
                                       blank=True, default=''),
        meta_title=models.CharField(verbose_name=_('project meta title'),
                                    help_text=_('used in title tag and social sharing'),
                                    max_length=2000,
                                    blank=True, default=''),
        meta={'unique_together': (('language_code', 'slug'),)}
    )

    class Meta:
        verbose_name = _('work type')
        verbose_name_plural = _('work types')

    def __str__(self):
        default = ugettext('Work (no translation)')
        return self.safe_translation_getter('name', any_language=True, default=default)


class Project(TranslatableModel, ModelMeta):
    work = models.ForeignKey(WorkType, verbose_name=_("Work type"), related_name="Projects", on_delete=models.CASCADE)
    translations = TranslatedFields(
        meta_description=models.TextField(
            verbose_name=_('project meta description'), blank=True, default=''
        ),
        meta_keywords=models.TextField(verbose_name=_('project meta keywords'),
                                       blank=True, default=''),
        meta_title=models.CharField(verbose_name=_('project meta title'),
                                    help_text=_('used in title tag and social sharing'),
                                    max_length=2000,
                                    blank=True, default=''),
    )

    main_image = FilerImageField(verbose_name=_('main image'), on_delete=models.CASCADE)
    sequence = models.IntegerField(verbose_name=_('sequence'))
    content = PlaceholderField('project_content', related_name='project_content')

    class Meta:
        ordering = ('sequence',)
        verbose_name = _('portfolio project')
        verbose_name_plural = _('portfolio projects')


    def get_absolute_url(self, lang=None):
        if not lang or lang not in self.get_available_languages():
            lang = get_language()
        if not lang or lang not in self.get_available_languages():
            lang = self.get_current_language()
        if self.has_translation(lang):
            work_slug = self.work.safe_translation_getter('slug', language_code=lang)
            project_id = self.pk
            return reverse('djangocms_portfolio:portfolio-detail', kwargs={'work_slug': work_slug, 'project_id': project_id})
        # in case category doesn't exist in this language, gracefully fallback
        # to portfolio list.
        return reverse('djangocms_portfolio:portfolio-list')
     
    def __str__(self):
        default = ugettext('Portoflio (no translation)')
        return self.work.safe_translation_getter('name', any_language=True, default=default)

    def thumbnail_options(self):
        return get_setting('IMAGE_THUMBNAIL_SIZE')

    def full_image_options(self):
        return get_setting('IMAGE_FULL_SIZE')

class PortfolioPlugin(CMSPlugin):
    title=models.CharField(_('title'), max_length=752, blank=True)
    description=models.TextField(verbose_name=_("description"), blank=True)
    portfolio = models.ManyToManyField(Project)

    def copy_relations(self, oldinstance):
        self.portfolio = oldinstance.portfolio.all()

djangocms_portfolio/views.py
from django.urls import reverse
from django.shortcuts import get_object_or_404
from django.utils.translation import get_language
from parler.views import TranslatableSlugMixin, ViewUrlMixin
from django.views.generic import DetailView, ListView

from .models import Project, WorkType

class BasePortfolioView(ViewUrlMixin):
    model = Project

    def get_view_url(self):
        if not self.view_url_name:
            raise ImproperlyConfigured(
                'Missing `view_url_name` attribute on {0}'.format(self.__class__.__name__)
            )

        url = reverse(self.view_url_name, args=self.args, kwargs=self.kwargs)
        return self.request.build_absolute_uri(url)

class BaseWorkView(ViewUrlMixin):
    model = WorkType

class BaseWorkListView(BaseWorkView):
    context_object_name = 'work_list'
    template_name = 'djangocms_portfolio/work_list.html'
    view_url_name = 'djangocms_portfolio:work-list'

class BasePortfolioListView(BasePortfolioView):
    context_object_name = 'portfolio_list'
    template_name = 'djangocms_portfolio/portfolio_list.html'
    view_url_name = 'djangocms_portfolio:portfolio-list'

    def get_context_data(self, **kwargs):
        context = super(BasePortfolioListView, self).get_context_data(**kwargs)
        return context

class PortfolioListView(BasePortfolioListView, ListView):
    pass

class PortfolioDetailView(BasePortfolioView, DetailView):
    context_object_name = 'portfolio'
    template_name = 'djangocms_portfolio/portfolio_detail.html'
    #slug_field = 'slug'
    pk_url_kwarg = 'project_id'
    view_url_name = 'djangocms_portfolio:portfolio-detail'

    def get_context_data(self, **kwargs):
        context = super(PortfolioDetailView, self).get_context_data(**kwargs)
        context['meta'] = self.get_object().as_meta()
        return context

class WorkListView(BaseWorkListView, ListView):
    pass

class WorkDetailView(TranslatableSlugMixin, BaseWorkView, DetailView):
    pass

djangocms_portfolio/templates/djangocms_portfolio/base.html
{% extends CMS_TEMPLATE %}

{% block meta %}
    {%  if meta %}
        {% include "meta/meta.html" %}
    {% endif %}
{% endblock meta %}

{% block content %}
<div class="app app-portfolio">
    {% block content_portfolio %}{% endblock content_portfolio %}
</div>
{% endblock content %}

djangocms_portfolio/templates/djangocms_portfolio/includes/portfolio_item.html
{% load i18n easy_thumbnails_tags cms_tags %}

<div id="portfolio-{{ portfolio.sequence }}" class="portfolio-item">
    <header>
        <h3><a href="{{ portfolio.get_absolute_url }}">{{ portfolio.work.name }}</a></h3>
    </header>
    <div class="blog-visual">
        {% thumbnail portfolio.main_image portfolio.thumbnail_options.size crop=portfolio.thumbnail_options.crop upscale=portfolio.thumbnail_options.upscale subject_location=portfolio.main_image.subject_location as thumb %}
        <img src="{{ thumb.url }}" alt="{{ portfolio.main_image.default_alt_text }}" width="{{ thumb.width }}" height="{{ thumb.height }}" />
    </div>
    <footer class="read-more">
        <a href="{{ portfolio.get_absolute_url }}">{% trans "read more" %}</a>
    </footer>
</div>

djangocms_portfolio/templates/djangocms_portfolio/includes/portfolio_meta.html
{% load i18n easy_thumbnails_tags cms_tags %}

<ul class="portfolio-detail tags">
    <li class="work_{{ portfolio.work.slug }}"><a href="{% url 'djangocms_portfolio:work-detail' portfolio.work.slug %}"></a>{{ portfolio.work.name }}</li>
</ul>

djangocms_portfolio/templates/djangocms_portfolio/plugins/portfolio_list.html
{% load i18n %}

<section class="portfolio-list">
	<header>
        <h2>{{ instance.title }}</h2>
        <p>{{ instance.description }}</p>
    </header>
    <div class="row">
        {% for portfolio in instance.portfolio.all %}
        {% include "djangocms_portfolio/includes/portfolio_item.html" with portfolio=portfolio %}
        {% endfor %}    
    </div>
</section>

djangocms_portfolio/templates/djangocms_portfolio/portfolio_detail.html
{% extends "djangocms_portfolio/base.html" %}
{% load i18n easy_thumbnails_tags cms_tags %}

{% block canonical_url %}<link rel="canonical" href="{{ meta.url }}"/>{% endblock canonical_url %}
{% block title %}{{ portfolio.get_title }}{% endblock %}

{% block content_portfolio %}{% spaceless %}
<div id="portfolio-{{ portfolio.work.slug }}" class="portfolio-item post-detail">
    <header>
        <h2>{% render_model portfolio.work "name" %}</h2>

    </header>
    <div class="blog-visual">
        {% thumbnail portfolio.main_image portfolio.full_image_options.size crop=portfolio.full_image_options.crop upscale=portfolio.full_image_options.upscale subject_location=portfolio.main_image.subject_location as thumb %}
        <img src="{{ thumb.url }}" alt="{{ portfolio.main_image.default_alt_text }}" width="{{ thumb.width }}" height="{{ thumb.height }}" />
    </div>
    {% endspaceless %}
        <div class="blog-content">{% render_placeholder portfolio.content %}</div>
    {% if post.related.exists %}
        <section class="post-detail-list">
        {% for related in post.related.all %}
            {% include "djangocms_blog/includes/blog_item.html" with post=related image="true" TRUNCWORDS_COUNT=TRUNCWORDS_COUNT %}
        {% endfor %}
        </section>
    {% endif %}
</article>
{% endblock content_portfolio %}

djangocms_portfolio/templates/djangocms_portfolio/portfolio_list.html
{% extends "djangocms_portfolio/base.html" %}
{% load i18n %}

{% block content_portfolio %}
<section class="portfolio-list">
	{% block portfolio_title %}
	{% if work_type %}
	<header>
		<h2>{{ work_type }}</h2>
	</header>
	{% endif %}
	{% endblock portfolio_title %}
	{% for portfolio in portfolio_list %}
	{% include "djangocms_portfolio/includes/portfolio_item.html" with portfolio=portfolio %}
	{% endfor %}
</section>
{% endblock content_portfolio %}

web_mvc/templates/menu.html
{% load i18n menu_tags cache %}

{% for child in children %}
    <li class="{% if child.ancestor %}ancestor{% endif %}
        {% if child.selected %} active{% endif %}
        {% if child.children %} dropdown{% endif %} nav-item" role="presentation">
        {% if child.children %}
            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">{{ child.get_menu_title }}<span class="caret"></span></a>
            <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                <!-- {% show_menu from_level to_level extra_inactive extra_active template "" "" child %} -->
                {% for subchild in child.children %}
                <a href="{{ subchild.get_absolute_url }}" class="dropdown-item">{{ subchild.get_menu_title }}</a>
                {% endfor %}
            </div>
        {% else %}
            <a class="nav-link" href="{{ child.get_absolute_url }}">{{ child.get_menu_title }}</a>
        {% endif %}
    </li>
    {% if class and forloop.last and not forloop.parentloop %}{% endif %}
{% endfor %}

web_mvc/templates/page.html
{% load cms_tags staticfiles sekizai_tags menu_tags %}
<!doctype html>
<html lang="{{ LANGUAGE_CODE }}">
    <head>
        <meta charset="utf-8">
        <title>{% block title %}{{ request.site.name }} - {% page_attribute "page_title" %}{% endblock title %}</title>
        <meta name="viewport" content="width=device-width,initial-scale=1.0">
        
        <!-- Favicons -->
        <link href="{% static 'img/favicon.png' %}" rel="icon">
        <link href="{% static 'img/apple-touch-icon.png' %}" rel="apple-touch-icon">

        <link rel="stylesheet" href="{% static 'bootstrap/css/bootstrap.min.css' %}">
        <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.3.1/css/all.css" integrity="sha384-mzrmE5qonljUremFsqc01SB46JvROS7bZs3IO2EmfFsd15uHvIt+Y8vEf7N7fWAU" crossorigin="anonymous">
        {% render_block "css" %}
        
        {% block meta %}
            {% include 'djangocms_page_meta/meta.html' with meta=page_meta %}
        {% endblock meta %}
        {% render_block "meta" %}
    </head>
    <body>
        {% cms_toolbar %}
        {% block feature %}
        <nav class="navbar navbar-expand-md navbar-dark bg-dark sticky-top">
            <div class="container">
                <a class="navbar-brand js-scroll" href="/">{{ request.site.name }}</a>
                <button class="navbar-toggler collapsed" type="button" data-toggle="collapse" data-target="#navbarDefault"
                aria-controls="navbarDefault" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse justify-content-end" id="navbarDefault">
                    <ul class="navbar-nav">
                        {% show_menu 0 1 100 100 "menu.html" %}
                    </ul>
                </div>
            </div>
        </nav>
        {% endblock feature %}

        <section>
            <div class="container">
                <div class="row">
                    <div class="col-md-{% block content_col %}12{% endblock content_col %}">
                        {% block content %}{% placeholder "content" %}{% endblock content %}
                    </div>
                    {% block sidebar %}{% endblock sidebar %}  
                </div>
            </div>
        </section>

        {% block footer %}{% endblock footer %}
        <script src="{% static 'js/jquery.min.js' %}"></script>
        <script src="{% static 'bootstrap/js/bootstrap.min.js' %}"></script>
        {% render_block "js" %}
    </body>
</html>